
AC_DEFUN([ACX_POPCNT], [
  AC_REQUIRE([AC_CANONICAL_HOST])
  AC_LANG_SAVE
  AC_LANG_C

  POPCNT_CFLAGS=""
  acx_popcnt_ok=no

  save_CFLAGS="$CFLAGS"
  CFLAGS="$CFLAGS -mpopcnt"

  AC_MSG_CHECKING(whether -mpopcnt compiler flag works)
  AC_TRY_LINK([ ],
              [__builtin_popcount(1); ],
              [acx_popcnt_ok=yes])

  CFLAGS="$save_CFLAGS"

  AC_MSG_RESULT($acx_popcnt_ok)
  if test "x$acx_popcnt_ok" = xyes; then
    POPCNT_CFLAGS="-mpopcnt"
  fi

  AC_SUBST(POPCNT_CFLAGS)

AC_LANG_RESTORE
])dnl

